.386
.model flat,stdcall
option casemap:none

include Register1.inc

.data

reg_lpType	dd	0

.code

start:

	invoke GetModuleHandle,NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke InitCommonControls
	mov		CommandLine,eax
	invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL	wc:WNDCLASSEX
	LOCAL	msg:MSG

	mov		wc.cbSize,sizeof WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc,offset WndProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground,COLOR_BTNFACE+1
	mov		wc.lpszMenuName,IDM_MENU
	mov		wc.lpszClassName,offset ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	invoke CreateDialogParam,hInstance,IDD_DIALOG,NULL,addr WndProc,NULL
	invoke ShowWindow,hWnd,SW_SHOWNORMAL
	invoke UpdateWindow,hWnd
	.while TRUE
		invoke GetMessage,addr msg,NULL,0,0
	  .BREAK .if !eax
		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw
	mov		eax,msg.wParam
	ret

WinMain endp

WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM


	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		push	hWin
		pop		hWnd
		invoke	GetDlgItem, hWnd, IDC_EDT1			; Get the handle for the edit box
		mov		hEdit, eax							; save handle. 
		mov		eax, REG_SZ
		mov		keyType, eax
	.elseif eax==WM_COMMAND
		mov		eax,wParam
		and		eax,0FFFFh
		.if eax==IDM_FILE_EXIT
			invoke SendMessage,hWin,WM_CLOSE,0,0
		.elseif eax==IDC_BTN
			;int 3
			invoke	RegOpenKeyEx, HKEY_LOCAL_MACHINE, addr szKey, 0, KEY_READ, addr hKey
			.if eax!=ERROR_SUCCESS 
				invoke	MessageBox, hWnd, addr NoKeyErr, addr AppName, MB_OK
			.endif
			
			; (!)	hKey is NOT returned from RegOpenKeyEx in EAX
			;	it is returned in hKey allready
			;	(thats why You pass --> addr hKey <-- to RegOpenKeyEx above
			;	to make it know where to put hKey value)
			;	below line -> mov hKey,eax <- overvrites it to 0	
			;mov		hKey, eax		; if key was open correctly, save the handle for later use
			
			invoke	MessageBox, hWnd, addr szKey, addr AppName, MB_OK
			;mov		buffsize, 16
			invoke	MessageBox, hWnd, addr szValue, addr AppName, MB_OK
			mov		buffsize, 256
			
			
			; (!)	You forgot to put in below line lpType parameter
			;	indicating that You expect it to be szString value
			invoke	RegQueryValueEx, hKey, addr szValue, 0, addr reg_lpType, addr buff, addr buffsize
			mov eax,offset buff
			mov ebx,offset buffsize
			int 3
			
			;	so it should be as in line below
			;invoke	RegQueryValueEx, hKey, addr szValue, 0, 0, addr buff, addr buffsize
			
			
			.if eax!=ERROR_SUCCESS
				invoke	MessageBox, hWnd, addr NoValue, addr AppName, MB_OK
			.endif
			invoke	SetWindowText, hEdit, addr buff
		.elseif eax==IDM_HELP_ABOUT
			invoke ShellAbout,hWin,addr AppName,addr AboutMsg,NULL
		.endif
;	.elseif eax==WM_SIZE
	.elseif eax==WM_CLOSE
		invoke	RegCloseKey, hKey
		invoke DestroyWindow,hWin
	.elseif uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.else
		invoke DefWindowProc,hWin,uMsg,wParam,lParam
		ret
	.endif
	xor    eax,eax
	ret

WndProc endp

end start
